/*
 * Copyright (c) 2023 - 2024. KeyWare.Co.Ltd All rights reserved.
 * 项目名称：信息安全性设计准则检查插件
 * 项目描述：用于检查源代码的安全性设计准则的Sonarqube插件
 * 版权说明：本软件属北京关键科技股份有限公司所有，在未获得北京关键科技股份有限公司正式授权情况下，任何企业和个人，不能获取、阅读、安装、传播本软件涉及的任何受知识产权保护的内容。
 */

import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

public class ExampleServlet {
    private static final long serialVersionUID = 1391640560504378168L;

    public class AuthenticationFilter implements Filter {
        public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException {// Noncompliant {{对用户进行身份鉴别并建立一个新的会话时让原来的会话失效}}
//            HttpServletRequest request = (HttpServletRequest) req;
//            boolean isValidUser = false;
//            String username = request.getParameter("username");
//            String password = request.getParameter("password");
//            // 这里应通过相关业务逻辑来验证用户名和密码的准确性
            isValidUser = UserService.validate(username, password);
            if (isValidUser) {
                HttpSession oldSession = request.getSession(false);
                if (oldSession != null) {
                    oldSession.invalidate();
                }
                HttpSession newSession = request.getSession(true);
                newSession.setMaxInactiveInterval(30 * 60);
                newSession.setAttribute("username", username);
                chain.doFilter(req, resp); // 继续执行下一个过滤器或请求
            } else {
                request.getRequestDispatcher("/login.jsp").forward(request, resp); // 跳转到登录页面
            }
        }
    }

    public class AuthenticationInterceptor extends HandlerInterceptorAdapter {
        @Override
        public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {// Noncompliant {{对用户进行身份鉴别并建立一个新的会话时让原来的会话失效}}
            boolean isValidUser = false;
            String username = request.getParameter("username");
            String password = request.getParameter("password");
            isValidUser = UserService.validate(username, password);
            if (isValidUser) {
                HttpSession oldSession = request.getSession(false);
                if (oldSession != null) {
//                    oldSession.invalidate();
                }
                HttpSession newSession = request.getSession(true);
                newSession.setMaxInactiveInterval(30 * 60);
                newSession.setAttribute("username", username);
                return true; // 继续下一个拦截器或请求处理器
            } else {
                response.sendRedirect("/login.jsp"); // 跳转到登录页面
                return false;
            }
        }
    }
}